# Copyright (C) 2012 Linaro
#
# This file is part of linaro-ci-dashboard.
#
# linaro-ci-dashboard is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# linaro-ci-dashboard is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with linaro-ci-dashboard.  If not, see <http://www.gnu.org/licenses/>.

from django.forms import ModelForm
from django.forms import ValidationError
from frontend.android_build.models.android_loop import (
    AndroidLoop,
    BUILD_ANDROID_TOOLCHAIN_LINARO,
    )


class AndroidLoopForm(ModelForm):
    class Meta:
        model = AndroidLoop
        exclude = ('server', 'config')

    def clean(self):
        cleaned_data = super(AndroidLoopForm, self).clean()
        if cleaned_data.get('build_type') == BUILD_ANDROID_TOOLCHAIN_LINARO[0]:
            if cleaned_data['gcc_url'] == '':
                raise ValidationError("With build of type 'Android Toolchain "
                                        "Linaro, it is necessary to specify "
                                        "GCC URL.")
        return cleaned_data
